function ajax_ts_checkbox(table_id)
{
    table = $("#"+table_id);
    table.find('th.checkbox').html('<input type="checkbox" id="allcheckbox" value="false" onclick="enableOrDisableAllCheckButton('+"'"+table_id+"')"+'"/>');
    table.bind('update','getCheckboxState()');
    table.tablesorter().bind('pagerComplete',function(e,table){
        $("#"+table_id+' td input:checkbox:visible').each(function(){
            $(this).prop('checked',getCheckbox(this));
        });
    });

    let parent = "#"+table_id;
    let listName = 'checkboxList';
    let list = $( parent ).data(listName);
}

function enableOrDisableCheckButton(selector){
    let key = $(selector).prop('name');
    let value = $(selector).prop('checked');
    setCheckbox($(selector).closest('table'),key,value);

    var form = $(selector).closest('form');

    if( $('td input:checked').length>0 ){
        form.find("a.button").removeClass("disabled");
    }
    else{
        form.find("a.button").addClass("disabled");
    }
 }

 function enableOrDisableAllCheckButton(tablesorter_id)
 {
    let url = $('#'+tablesorter_id).data("tablesorter").pager.ajaxObject.url;
    let value = $('#'+tablesorter_id+' #allcheckbox').prop('checked');

    setCheckbox('#'+tablesorter_id,'default',value);
    if( url !== undefined )
    {
        $.getJSON( url+'&mode=idList', function( data ) {
          $.each( data, function( key, val ) {
            setCheckbox('#'+tablesorter_id,val,value);
          });
        });
    }
    $(".checkbox input:checkbox:visible").prop('checked', $('#'+tablesorter_id+' #allcheckbox').prop('checked'));
    enableOrDisableCheckButton('#'+tablesorter_id);
 }

function getOrInitList(parent,listName)
{
    let list = {};

    if( typeof $( parent ).data(listName) === 'undefined' )
    {
        list['default'] = false;
        $( parent ).data(listName,list);
    }

    list = $( parent ).data(listName);
    return list;
}

function setCheckbox(selector,key,value)
{
    let parent = selector;

    if( key == "" ) return;
    if( key === undefined ) return;

    let listName = 'checkboxList';
    let list = getOrInitList(parent,listName);

    if( value )
    {
        list[key] = value;
    }
    else
    {
        delete list[key];
    }

    $( parent ).data(listName,list);
}

function getCheckbox(selector)
{
    let key = '';
    let value = '';
    let parent = $(selector).closest('table');
    if( selector == '#allcheckbox' )
    {
        key = 'default';
        value = $('#allcheckbox').prop('checked');
    }
    else
    {
        key = $(selector).prop('name');
        value = $(selector).prop('checked');
    }

    let listName = 'checkboxList';
    let list = getOrInitList(parent,listName);

    if( typeof list[key] !== 'undefined' )
    {
        return list[key];
    }
    return false;
}

 function dialog_confirm_checkbox(table_id,css_selector,dialogName,close)
  {
    let parent = "#"+table_id;
    let listName = 'checkboxList';
    let list = $( parent ).data(listName);
    let ok_text = $( css_selector ).data('btnok-text');
    let cancel_text = $( css_selector ).data('btncancel-text');
    let exit_text = $( css_selector ).data('btnexit-text');

    $(css_selector).attr('href',$(css_selector).attr('href'));

    let width = 1280
    let height = 720;

    let adm_dialog = $("<div></div>");
    adm_dialog.attr('id','acqConfirmDialog');
    adm_dialog.attr('title',dialogName);
    $( "body" ).append(adm_dialog);

    let jsonString = JSON.stringify(list);
    let posting = $.post( $(css_selector).attr('href'),{'case-list':jsonString});

    posting.done(function( data ) {
      	 adm_dialog.append( data);
    } );

    adm_dialog.dialog({resizable: true,modal: true,  autoOpen: false,width: width,height: height,  close: function(event, ui) {window.location.reload();}  });

    $( '.ui-dialog-titlebar-close' ).css("display","block"); //Pour les bugs occasionels dans les boites de dialogs.


    adm_dialog.dialog({
      buttons:
      [
        {
          text: ok_text,
          click : function(){
            $( '.ui-dialog-buttonset .ui-button' ).not('.btnBack').hide();
            $( '.ui-dialog-buttonset .ui-button.btnBack .ui-button-text' ).html(exit_text);

            let posting = $.post( $(css_selector).attr('href')+'&'+'action=save',{'case-list':jsonString});
            posting.done(function( data ) {
                 adm_dialog.html('');
                 adm_dialog.append( data);
            } );
          }
        },
        {
          text: cancel_text,
          create: function()
          {
            $( this ).addClass( "btnBack" );
          },
          click : function()
          {
            adm_dialog.dialog( "close" );
          }
        }
      ]
  });

  adm_dialog.dialog('open');

 }
